char* keyname(int i)
{
  switch(i)
    {
    case 0: return "KEY_RESERVED";
    case 1: return "KEY_ESC";
    case 2: return "KEY_1";
    case 3: return "KEY_2";
    case 4: return "KEY_3";
    case 5: return "KEY_4";
    case 6: return "KEY_5";
    case 7: return "KEY_6";
    case 8: return "KEY_7";
    case 9: return "KEY_8";
    case 10: return "KEY_9";
    case 11: return "KEY_0";
    case 12: return "KEY_MINUS";
    case 13: return "KEY_EQUAL";
    case 14: return "KEY_BACKSPACE";
    case 15: return "KEY_TAB";
    case 16: return "KEY_Q";
    case 17: return "KEY_W";
    case 18: return "KEY_E";
    case 19: return "KEY_R";
    case 20: return "KEY_T";
    case 21: return "KEY_Y";
    case 22: return "KEY_U";
    case 23: return "KEY_I";
    case 24: return "KEY_O";
    case 25: return "KEY_P";
    case 26: return "KEY_LEFTBRACE";
    case 27: return "KEY_RIGHTBRACE";
    case 28: return "KEY_ENTER";
    case 29: return "KEY_LEFTCTRL";
    case 30: return "KEY_A";
    case 31: return "KEY_S";
    case 32: return "KEY_D";
    case 33: return "KEY_F";
    case 34: return "KEY_G";
    case 35: return "KEY_H";
    case 36: return "KEY_J";
    case 37: return "KEY_K";
    case 38: return "KEY_L";
    case 39: return "KEY_SEMICOLON";
    case 40: return "KEY_APOSTROPHE";
    case 41: return "KEY_GRAVE";
    case 42: return "KEY_LEFTSHIFT";
    case 43: return "KEY_BACKSLASH";
    case 44: return "KEY_Z";
    case 45: return "KEY_X";
    case 46: return "KEY_C";
    case 47: return "KEY_V";
    case 48: return "KEY_B";
    case 49: return "KEY_N";
    case 50: return "KEY_M";
    case 51: return "KEY_COMMA";
    case 52: return "KEY_DOT";
    case 53: return "KEY_SLASH";
    case 54: return "KEY_RIGHTSHIFT";
    case 55: return "KEY_KPASTERISK";
    case 56: return "KEY_LEFTALT";
    case 57: return "KEY_SPACE";
    case 58: return "KEY_CAPSLOCK";
    case 59: return "KEY_F1";
    case 60: return "KEY_F2";
    case 61: return "KEY_F3";
    case 62: return "KEY_F4";
    case 63: return "KEY_F5";
    case 64: return "KEY_F6";
    case 65: return "KEY_F7";
    case 66: return "KEY_F8";
    case 67: return "KEY_F9";
    case 68: return "KEY_F10";
    case 69: return "KEY_NUMLOCK";
    case 70: return "KEY_SCROLLLOCK";
    case 71: return "KEY_KP7";
    case 72: return "KEY_KP8";
    case 73: return "KEY_KP9";
    case 74: return "KEY_KPMINUS";
    case 75: return "KEY_KP4";
    case 76: return "KEY_KP5";
    case 77: return "KEY_KP6";
    case 78: return "KEY_KPPLUS";
    case 79: return "KEY_KP1";
    case 80: return "KEY_KP2";
    case 81: return "KEY_KP3";
    case 82: return "KEY_KP0";
    case 83: return "KEY_KPDOT";

    case 85: return "KEY_ZENKAKUHANKAKU";
    case 86: return "KEY_102ND";
    case 87: return "KEY_F11";
    case 88: return "KEY_F12";
    case 89: return "KEY_RO";
    case 90: return "KEY_KATAKANA";
    case 91: return "KEY_HIRAGANA";
    case 92: return "KEY_HENKAN";
    case 93: return "KEY_KATAKANAHIRAGANA";
    case 94: return "KEY_MUHENKAN";
    case 95: return "KEY_KPJPCOMMA";
    case 96: return "KEY_KPENTER";
    case 97: return "KEY_RIGHTCTRL";
    case 98: return "KEY_KPSLASH";
    case 99: return "KEY_SYSRQ";
    case 100: return "KEY_RIGHTALT";
    case 101: return "KEY_LINEFEED";
    case 102: return "KEY_HOME";
    case 103: return "KEY_UP";
    case 104: return "KEY_PAGEUP";
    case 105: return "KEY_LEFT";
    case 106: return "KEY_RIGHT";
    case 107: return "KEY_END";
    case 108: return "KEY_DOWN";
    case 109: return "KEY_PAGEDOWN";
    case 110: return "KEY_INSERT";
    case 111: return "KEY_DELETE";
    case 112: return "KEY_MACRO";
    case 113: return "KEY_MUTE";
    case 114: return "KEY_VOLUMEDOWN";
    case 115: return "KEY_VOLUMEUP";
    case 116: return "KEY_POWER";
    case 117: return "KEY_KPEQUAL";
    case 118: return "KEY_KPPLUSMINUS";
    case 119: return "KEY_PAUSE";

    case 121: return "KEY_KPCOMMA";
    case 122: return "KEY_HANGUEL";
    case 123: return "KEY_HANJA";
    case 124: return "KEY_YEN";
    case 125: return "KEY_LEFTMETA";
    case 126: return "KEY_RIGHTMETA";
    case 127: return "KEY_COMPOSE";

    case 128: return "KEY_STOP";
    case 129: return "KEY_AGAIN";
    case 130: return "KEY_PROPS";
    case 131: return "KEY_UNDO";
    case 132: return "KEY_FRONT";
    case 133: return "KEY_COPY";
    case 134: return "KEY_OPEN";
    case 135: return "KEY_PASTE";
    case 136: return "KEY_FIND";
    case 137: return "KEY_CUT";
    case 138: return "KEY_HELP";
    case 139: return "KEY_MENU";
    case 140: return "KEY_CALC";
    case 141: return "KEY_SETUP";
    case 142: return "KEY_SLEEP";
    case 143: return "KEY_WAKEUP";
    case 144: return "KEY_FILE";
    case 145: return "KEY_SENDFILE";
    case 146: return "KEY_DELETEFILE";
    case 147: return "KEY_XFER";
    case 148: return "KEY_PROG1";
    case 149: return "KEY_PROG2";
    case 150: return "KEY_WWW";
    case 151: return "KEY_MSDOS";
    case 152: return "KEY_COFFEE";
    case 153: return "KEY_DIRECTION";
    case 154: return "KEY_CYCLEWINDOWS";
    case 155: return "KEY_MAIL";
    case 156: return "KEY_BOOKMARKS";
    case 157: return "KEY_COMPUTER";
    case 158: return "KEY_BACK";
    case 159: return "KEY_FORWARD";
    case 160: return "KEY_CLOSECD";
    case 161: return "KEY_EJECTCD";
    case 162: return "KEY_EJECTCLOSECD";
    case 163: return "KEY_NEXTSONG";
    case 164: return "KEY_PLAYPAUSE";
    case 165: return "KEY_PREVIOUSSONG";
    case 166: return "KEY_STOPCD";
    case 167: return "KEY_RECORD";
    case 168: return "KEY_REWIND";
    case 169: return "KEY_PHONE";
    case 170: return "KEY_ISO";
    case 171: return "KEY_CONFIG";
    case 172: return "KEY_HOMEPAGE";
    case 173: return "KEY_REFRESH";
    case 174: return "KEY_EXIT";
    case 175: return "KEY_MOVE";
    case 176: return "KEY_EDIT";
    case 177: return "KEY_SCROLLUP";
    case 178: return "KEY_SCROLLDOWN";
    case 179: return "KEY_KPLEFTPAREN";
    case 180: return "KEY_KPRIGHTPAREN";

    case 183: return "KEY_F13";
    case 184: return "KEY_F14";
    case 185: return "KEY_F15";
    case 186: return "KEY_F16";
    case 187: return "KEY_F17";
    case 188: return "KEY_F18";
    case 189: return "KEY_F19";
    case 190: return "KEY_F20";
    case 191: return "KEY_F21";
    case 192: return "KEY_F22";
    case 193: return "KEY_F23";
    case 194: return "KEY_F24";

    case 200: return "KEY_PLAYCD";
    case 201: return "KEY_PAUSECD";
    case 202: return "KEY_PROG3";
    case 203: return "KEY_PROG4";
    case 205: return "KEY_SUSPEND";
    case 206: return "KEY_CLOSE";
    case 207: return "KEY_PLAY";
    case 208: return "KEY_FASTFORWARD";
    case 209: return "KEY_BASSBOOST";
    case 210: return "KEY_PRINT";
    case 211: return "KEY_HP";
    case 212: return "KEY_CAMERA";
    case 213: return "KEY_SOUND";
    case 214: return "KEY_QUESTION";
    case 215: return "KEY_EMAIL";
    case 216: return "KEY_CHAT";
    case 217: return "KEY_SEARCH";
    case 218: return "KEY_CONNECT";
    case 219: return "KEY_FINANCE";
    case 220: return "KEY_SPORT";
    case 221: return "KEY_SHOP";
    case 222: return "KEY_ALTERASE";
    case 223: return "KEY_CANCEL";
    case 224: return "KEY_BRIGHTNESSDOWN";
    case 225: return "KEY_BRIGHTNESSUP";
    case 226: return "KEY_MEDIA";

    case 240: return "KEY_UNKNOWN";

    case 0x100: return "BTN_0/BTN_MISC";
    case 0x101: return "BTN_1";
    case 0x102: return "BTN_2";
    case 0x103: return "BTN_3";
    case 0x104: return "BTN_4";
    case 0x105: return "BTN_5";
    case 0x106: return "BTN_6";
    case 0x107: return "BTN_7";
    case 0x108: return "BTN_8";
    case 0x109: return "BTN_9";

    case 0x110: return "BTN_MOUSE/BTN_LEFT";
    case 0x111: return "BTN_RIGHT";
    case 0x112: return "BTN_MIDDLE";
    case 0x113: return "BTN_SIDE";
    case 0x114: return "BTN_EXTRA";
    case 0x115: return "BTN_FORWARD";
    case 0x116: return "BTN_BACK";
    case 0x117: return "BTN_TASK";

    case 0x120: return "BTN_JOYSTICK/BTN_TRIGGER";
    case 0x121: return "BTN_THUMB";
    case 0x122: return "BTN_THUMB2";
    case 0x123: return "BTN_TOP";
    case 0x124: return "BTN_TOP2";
    case 0x125: return "BTN_PINKIE";
    case 0x126: return "BTN_BASE";
    case 0x127: return "BTN_BASE2";
    case 0x128: return "BTN_BASE3";
    case 0x129: return "BTN_BASE4";
    case 0x12a: return "BTN_BASE5";
    case 0x12b: return "BTN_BASE6";
    case 0x12f: return "BTN_DEAD";

    case 0x130: return "BTN_GAMEPAD/BTN_A";
    case 0x131: return "BTN_B";
    case 0x132: return "BTN_C";
    case 0x133: return "BTN_X";
    case 0x134: return "BTN_Y";
    case 0x135: return "BTN_Z";
    case 0x136: return "BTN_TL";
    case 0x137: return "BTN_TR";
    case 0x138: return "BTN_TL2";
    case 0x139: return "BTN_TR2";
    case 0x13a: return "BTN_SELECT";
    case 0x13b: return "BTN_START";
    case 0x13c: return "BTN_MODE";
    case 0x13d: return "BTN_THUMBL";
    case 0x13e: return "BTN_THUMBR";

    case 0x140: return "BTN_DIGI/BTN_TOOL_PEN";
    case 0x141: return "BTN_TOOL_RUBBER";
    case 0x142: return "BTN_TOOL_BRUSH";
    case 0x143: return "BTN_TOOL_PENCIL";
    case 0x144: return "BTN_TOOL_AIRBRUSH";
    case 0x145: return "BTN_TOOL_FINGER";
    case 0x146: return "BTN_TOOL_MOUSE";
    case 0x147: return "BTN_TOOL_LENS";
    case 0x14a: return "BTN_TOUCH";
    case 0x14b: return "BTN_STYLUS";
    case 0x14c: return "BTN_STYLUS2";
    case 0x14d: return "BTN_TOOL_DOUBLETAP";
    case 0x14e: return "BTN_TOOL_TRIPLETAP";

    case 0x150: return "BTN_WHEEL/BTN_GEAR_DOWN";
    case 0x151: return "BTN_GEAR_UP";

    case 0x160: return "KEY_OK";
    case 0x161: return "KEY_SELECT";
    case 0x162: return "KEY_GOTO";
    case 0x163: return "KEY_CLEAR";
    case 0x164: return "KEY_POWER2";
    case 0x165: return "KEY_OPTION";
    case 0x166: return "KEY_INFO";
    case 0x167: return "KEY_TIME";
    case 0x168: return "KEY_VENDOR";
    case 0x169: return "KEY_ARCHIVE";
    case 0x16a: return "KEY_PROGRAM";
    case 0x16b: return "KEY_CHANNEL";
    case 0x16c: return "KEY_FAVORITES";
    case 0x16d: return "KEY_EPG";
    case 0x16e: return "KEY_PVR";
    case 0x16f: return "KEY_MHP";
    case 0x170: return "KEY_LANGUAGE";
    case 0x171: return "KEY_TITLE";
    case 0x172: return "KEY_SUBTITLE";
    case 0x173: return "KEY_ANGLE";
    case 0x174: return "KEY_ZOOM";
    case 0x175: return "KEY_MODE";
    case 0x176: return "KEY_KEYBOARD";
    case 0x177: return "KEY_SCREEN";
    case 0x178: return "KEY_PC";
    case 0x179: return "KEY_TV";
    case 0x17a: return "KEY_TV2";
    case 0x17b: return "KEY_VCR";
    case 0x17c: return "KEY_VCR2";
    case 0x17d: return "KEY_SAT";
    case 0x17e: return "KEY_SAT2";
    case 0x17f: return "KEY_CD";
    case 0x180: return "KEY_TAPE";
    case 0x181: return "KEY_RADIO";
    case 0x182: return "KEY_TUNER";
    case 0x183: return "KEY_PLAYER";
    case 0x184: return "KEY_TEXT";
    case 0x185: return "KEY_DVD";
    case 0x186: return "KEY_AUX";
    case 0x187: return "KEY_MP3";
    case 0x188: return "KEY_AUDIO";
    case 0x189: return "KEY_VIDEO";
    case 0x18a: return "KEY_DIRECTORY";
    case 0x18b: return "KEY_LIST";
    case 0x18c: return "KEY_MEMO";
    case 0x18d: return "KEY_CALENDAR";
    case 0x18e: return "KEY_RED";
    case 0x18f: return "KEY_GREEN";
    case 0x190: return "KEY_YELLOW";
    case 0x191: return "KEY_BLUE";
    case 0x192: return "KEY_CHANNELUP";
    case 0x193: return "KEY_CHANNELDOWN";
    case 0x194: return "KEY_FIRST";
    case 0x195: return "KEY_LAST";
    case 0x196: return "KEY_AB";
    case 0x197: return "KEY_NEXT";
    case 0x198: return "KEY_RESTART";
    case 0x199: return "KEY_SLOW";
    case 0x19a: return "KEY_SHUFFLE";
    case 0x19b: return "KEY_BREAK";
    case 0x19c: return "KEY_PREVIOUS";
    case 0x19d: return "KEY_DIGITS";
    case 0x19e: return "KEY_TEEN";
    case 0x19f: return "KEY_TWEN";

    case 0x1c0: return "KEY_DEL_EOL";
    case 0x1c1: return "KEY_DEL_EOS";
    case 0x1c2: return "KEY_INS_LINE";
    case 0x1c3: return "KEY_DEL_LINE";

    case 0x1d0: return "KEY_FN";
    case 0x1d1: return "KEY_FN_ESC";
    case 0x1d2: return "KEY_FN_F1";
    case 0x1d3: return "KEY_FN_F2";
    case 0x1d4: return "KEY_FN_F3";
    case 0x1d5: return "KEY_FN_F4";
    case 0x1d6: return "KEY_FN_F5";
    case 0x1d7: return "KEY_FN_F6";
    case 0x1d8: return "KEY_FN_F7";
    case 0x1d9: return "KEY_FN_F8";
    case 0x1da: return "KEY_FN_F9";
    case 0x1db: return "KEY_FN_F10";
    case 0x1dc: return "KEY_FN_F11";
    case 0x1dd: return "KEY_FN_F12";
    case 0x1de: return "KEY_FN_1";
    case 0x1df: return "KEY_FN_2";
    case 0x1e0: return "KEY_FN_D";
    case 0x1e1: return "KEY_FN_E";
    case 0x1e2: return "KEY_FN_F";
    case 0x1e3: return "KEY_FN_S";
    case 0x1e4: return "KEY_FN_B";

    case 0x1ff: return "KEY_MAX";
    }
  return "undefined key!";
}
